; 
    include \masm32\include\masm32rt.inc
    .mmx
; 

    ;---------------------------------------------------------------
    ; This extends the MASM32 dialog macros to do modeless dialogs.
    ; NOTE THAT THIS HAS BEEN ADDED TO MASM32 V10
    ;---------------------------------------------------------------

    CallModelessDialog MACRO Instance,Parent,DlgProc,lParamInit

      invoke CreateDialogIndirectParam,Instance,esi,Parent,
                                       ADDR DlgProc,lParamInit
      push eax                ;; preserve return value
      invoke GlobalFree,esi   ;; free memory
      pop eax                 ;; restore return value
      pop edi
      pop esi

    ENDM

; 
    .data
      hDlg      dd 0
      hDC       dd 0
      hBrush    dd 0
      color     dd 0
      px        dd 0
      py        dd 0
      msg       MSG <>
      rc        RECT <>

      seed      dw 31415

    .code
; 

align 4
ddrb proc base:DWORD

    push ebx
    mov ax,seed ;seed
    mov ebx,56789
    mov edx,263
    movd MM0,eax
    movd MM1,ebx
    movd MM2,edx
    pmullw MM0,MM2
    paddw MM0,MM1
    movd eax,MM0 ;new seed
    mov seed,ax

    xor edx, edx
    div base
    mov eax, edx

    pop ebx
    ret
ddrb endp

; 

DlgProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDC, hwndDlg
        mov  hDC, eax

        invoke GetStockObject, WHITE_BRUSH
        mov hBrush, eax

      CASE WM_CTLCOLORDLG

        return hBrush

      CASE WM_SIZE

        invoke GetClientRect, hwndDlg, ADDR rc
        invoke FillRect, hDC, ADDR rc, hBrush

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDCANCEL

            invoke DestroyWindow, hwndDlg

        ENDSW

      CASE WM_CLOSE

        invoke DestroyWindow, hwndDlg

      CASE WM_DESTROY

        invoke PostQuitMessage, NULL

    ENDSW

    return 0

DlgProc endp
; 
start:
; 

    Dialog  "Test", \                         ; caption
            "Courier New Bold", 10, \         ; font,pointsize
            WS_OVERLAPPEDWINDOW or \          ; window style
            WS_VISIBLE or DS_CENTER, \
            0, \                              ; number of controls
            0,0,200,150, \                    ; x, y, width, height
            1024                              ; memory buffer size

    invoke GetModuleHandle, NULL
    CallModelessDialog eax, 0, DlgProc, NULL
    mov hDlg, eax

  msgLoop:

    invoke PeekMessage, ADDR msg, NULL, 0, 0, PM_REMOVE
    .IF eax

      .IF msg.message == WM_QUIT
        jmp @F
      .ENDIF
      invoke IsDialogMessage, hDlg, ADDR msg

    .ELSE

      invoke ddrb, 0ffffh
      mov color, eax

      invoke ddrb, rc.right
      mov px, eax

      invoke ddrb, rc.bottom
      mov py, eax

      invoke SetPixel,hDC,px,py,color

    .ENDIF
    jmp msgLoop

  @@:

    exit
; 
end start
